import { ref as C, computed as g, watch as I, nextTick as z, onBeforeUnmount as ye, reactive as ve, onMounted as Ae, getCurrentInstance as Ie, inject as qe, shallowReactive as _, markRaw as te, defineComponent as me, useAttrs as Re, toRef as re, openBlock as B, createBlock as U, Teleport as Je, unref as v, withDirectives as ae, createElementBlock as j, mergeProps as x, withKeys as Qe, withModifiers as Ce, Transition as ke, toHandlers as Ve, withCtx as pe, normalizeClass as _e, normalizeStyle as eo, vShow as ue, createCommentVNode as Y, createVNode as oo, renderSlot as Ee, normalizeProps as Fe, guardReactiveProps as to, createElementVNode as ee, Fragment as no, renderList as Be, resolveDynamicComponent as ce, createSlots as lo } from "vue";
import { useEventListener as F, tryOnUnmounted as so } from "@vueuse/core";
import { useFocusTrap as io } from "@vueuse/integrations/useFocusTrap";
const ro = (e) => (...o) => {
  e && (e == null || e(...o), e = null);
}, q = () => {
};
function oe(e, o, l) {
  return e > l ? l : e < o ? o : e;
}
const he = (e) => typeof e == "string";
function de(e, o) {
  var s;
  const l = ((s = $(e, o)) == null ? void 0 : s[0]) || o;
  e.push(l);
}
function $(e, o) {
  const l = e.indexOf(o);
  if (l !== -1)
    return e.splice(l, 1);
}
const ao = {
  /**
   * @description Set `null | false` to disable teleport.
   * @default `'body'`
   * @example
   * ```js
   * teleportTo: '#modals'
   * ```
   */
  teleportTo: {
    type: [String, null, Boolean, Object],
    default: "body"
  },
  /**
   * @description An uniq name for the open/close a modal via vfm.open/vfm.close APIs.
   * @default `undefined`
   * @example Symbol: `Symbol('MyModal')`
   * @example String: `'AUniqString'`
   * @example Number: `300`
   */
  modalId: {
    type: [String, Number, Symbol],
    default: void 0
  },
  /**
   * @description Display the modal or not.
   * @default `undefined`
   * @example
   * ```js
   * const showModal = ref(false)
   * v-model="showModal"
   * ```
   */
  modelValue: {
    type: Boolean,
    default: void 0
  },
  /**
   * @description Render the modal via `if` or `show`.
   * @default `'if'`
   * @example
   * ```js
   * displayDirective: 'if'
   * ```
   * @example
   * ```js
   * displayDirective: 'show'
   * ```
   */
  displayDirective: {
    type: String,
    default: "if",
    validator: (e) => ["if", "show", "visible"].includes(e)
  },
  /**
   * @description Hide the overlay or not.
   * @default `undefined`
   * @example
   * ```js
   * hideOverlay="true"
   * ```
   */
  hideOverlay: {
    type: Boolean,
    default: void 0
  },
  /**
   * @description Customize the overlay behavior.
   */
  overlayBehavior: {
    type: String,
    default: "auto",
    validator: (e) => ["auto", "persist"].includes(e)
  },
  /**
   * @description Customize the overlay transition.
   * @default `undefined`
   */
  overlayTransition: {
    type: [String, Object],
    default: void 0
  },
  /**
   * @description Customize the content transition.
   * @default `undefined`
   */
  contentTransition: {
    type: [String, Object],
    default: void 0
  },
  /**
   * @description Bind class to vfm__overlay.
   * @default `undefined`
   */
  overlayClass: {
    type: void 0,
    default: void 0
  },
  /**
   * @description Bind class to vfm__content.
   * @default `undefined`
   */
  contentClass: {
    type: void 0,
    default: void 0
  },
  /**
   * @description Bind style to vfm__overlay.
   * @default `undefined`
   */
  overlayStyle: {
    type: [String, Object, Array],
    default: void 0
  },
  /**
   * @description Bind style to vfm__content.
   * @default `undefined`
   */
  contentStyle: {
    type: [String, Object, Array],
    default: void 0
  },
  /**
   * @description Is it allow to close the modal by clicking the overlay.
   * @default `true`
   */
  clickToClose: {
    type: Boolean,
    default: !0
  },
  /**
   * @description Is it allow to close the modal by keypress `esc`.
   * @default `true`
   */
  escToClose: {
    type: Boolean,
    default: !0
  },
  /**
   * @description Is it allow to click outside of the vfm__content when the modal is opened
   * @default `'non-interactive'`
   */
  background: {
    type: String,
    default: "non-interactive",
    validator: (e) => ["interactive", "non-interactive"].includes(e)
  },
  /**
   * @description
   * * Use `{ disabled: true }` to disable the focusTrap.
   * * Checkout the createOptions type here https://github.com/focus-trap/focus-trap for more.
   * @default `{ allowOutsideClick: true }`
   */
  focusTrap: {
    type: [Boolean, Object],
    default: () => ({
      allowOutsideClick: !0
    })
  },
  /**
   * @description Lock body scroll or not when the modal is opened.
   * @default `true`
   */
  lockScroll: {
    type: Boolean,
    default: !0
  },
  /**
   * @description Creates a padding-right when scroll is locked to prevent the page from jumping
   * @default `true`
   */
  reserveScrollBarGap: {
    type: Boolean,
    default: !0
  },
  /**
   * @description Define how to increase the zIndex when there are nested modals
   * @default `({ index }) => 1000 + 2 * index`
   */
  zIndexFn: {
    type: Function,
    default: ({ index: e }) => 1e3 + 2 * e
  },
  /**
   * @description The direction of swiping to close the modal
   * @default `none`
   * @example
   * Set swipeToClose="none" to disable swiping to close
   * ```js
   * swipeToClose="none"
   * ```
   */
  swipeToClose: {
    type: String,
    default: "none",
    validator: (e) => ["none", "up", "right", "down", "left"].includes(e)
  },
  /**
   * @description Threshold for swipe to close
   * @default `0`
   */
  threshold: {
    type: Number,
    default: 0
  },
  /**
   * @description If set `:showSwipeBanner="true"`, only allow clicking `swipe-banner` slot to swipe to close
   * @default `undefined`
   * @example
   * ```js
   * swipeToClose="right"
   * :showSwipeBanner="true"
   * ```
   * ```html
   * <VueFinalModal
   *   ...
   *   swipeToClose="right"
   *   :showSwipeBanner="true"
   * >
   *   <template #swipe-banner>
   *     <div style="position: absolute; height: 100%; top: 0; left: 0; width: 10px;" />
   *   </template>
   *   ...modal content
   * </VueFinalModal>
   * ```
   */
  showSwipeBanner: {
    type: Boolean,
    default: void 0
  },
  /**
   * @description When set `:preventNavigationGestures="true"`, there will be two invisible bars for prevent navigation gestures including swiping back/forward on mobile webkit. For example: Safari mobile.
   * @default `undefined`
   * @example
   * Set preventNavigationGestures="true" to prevent Safari navigation gestures including swiping back/forward.
   * ```js
   * :preventNavigationGestures="true"
   * ```
   */
  preventNavigationGestures: {
    type: Boolean,
    default: void 0
  }
};
function Oe(e = !1) {
  const o = C(e), l = C(o.value ? 0 : void 0);
  return [o, l, {
    beforeEnter() {
      l.value = 1;
    },
    afterEnter() {
      l.value = 0;
    },
    beforeLeave() {
      l.value = 3;
    },
    afterLeave() {
      l.value = 2;
    }
  }];
}
function uo(e, o) {
  const { modelValueLocal: l, onEntering: s, onEnter: u, onLeaving: c, onLeave: a } = o, n = C(l.value), [t, i, h] = Oe(n.value), [f, M, S] = Oe(n.value), V = g(() => typeof e.contentTransition == "string" ? { name: e.contentTransition, appear: !0 } : { appear: !0, ...e.contentTransition }), O = g(() => typeof e.overlayTransition == "string" ? { name: e.overlayTransition, appear: !0 } : { appear: !0, ...e.overlayTransition }), E = g(
    () => (e.hideOverlay || M.value === 2) && i.value === 2
    /* Leave */
  );
  I(
    E,
    (k) => {
      k && (n.value = !1);
    }
  ), I(i, (k) => {
    if (k === 1) {
      if (!n.value)
        return;
      s == null || s();
    } else if (k === 0) {
      if (!n.value)
        return;
      u == null || u();
    } else
      k === 3 ? c == null || c() : k === 2 && (a == null || a());
  });
  async function T() {
    n.value = !0, await z(), t.value = !0, f.value = !0;
  }
  function D() {
    t.value = !1, f.value = !1;
  }
  return {
    visible: n,
    contentVisible: t,
    contentListeners: h,
    contentTransition: V,
    overlayVisible: f,
    overlayListeners: S,
    overlayTransition: O,
    enterTransition: T,
    leaveTransition: D
  };
}
function co(e, o, l) {
  const { vfmRootEl: s, vfmContentEl: u, visible: c, modelValueLocal: a } = l, n = C();
  function t() {
    c.value && e.escToClose && (a.value = !1);
  }
  function i(f) {
    n.value = f == null ? void 0 : f.target;
  }
  function h() {
    var f;
    n.value === s.value && (e.clickToClose ? a.value = !1 : ((f = u.value) == null || f.focus(), o("clickOutside")));
  }
  return {
    onEsc: t,
    onMouseupRoot: h,
    onMousedown: i
  };
}
function fo(e, o, l) {
  let s = !1;
  const { open: u, close: c } = l, a = C(!1), n = {
    get value() {
      return a.value;
    },
    set value(i) {
      t(i);
    }
  };
  function t(i) {
    (i ? u() : c()) ? (a.value = i, i !== e.modelValue && o("update:modelValue", i)) : (s = !0, o("update:modelValue", !i), z(() => {
      s = !1;
    }));
  }
  return I(() => e.modelValue, (i) => {
    s || (n.value = !!i);
  }), {
    modelValueLocal: n
  };
}
function vo(e, o) {
  if (e.focusTrap === !1)
    return {
      focus() {
      },
      blur() {
      }
    };
  const { focusEl: l } = o, { hasFocus: s, activate: u, deactivate: c } = io(l, e.focusTrap);
  function a() {
    requestAnimationFrame(() => {
      u();
    });
  }
  function n() {
    s.value && c();
  }
  return { focus: a, blur: n };
}
let we = !1;
if (typeof window < "u") {
  const e = {
    get passive() {
      we = !0;
    }
  };
  window.addEventListener("testPassive", null, e), window.removeEventListener("testPassive", null, e);
}
const He = typeof window < "u" && window.navigator && window.navigator.platform && (/iP(ad|hone|od)/.test(window.navigator.platform) || window.navigator.platform === "MacIntel" && window.navigator.maxTouchPoints > 1);
let N = [], le = !1, ne = 0, Ne = -1, W, X;
const po = (e) => {
  if (!e || e.nodeType !== Node.ELEMENT_NODE)
    return !1;
  const o = window.getComputedStyle(e);
  return ["auto", "scroll"].includes(o.overflowY) && e.scrollHeight > e.clientHeight;
}, yo = (e, o) => !(e.scrollTop === 0 && o < 0 || e.scrollTop + e.clientHeight + o >= e.scrollHeight && o > 0), mo = (e) => {
  const o = [];
  for (; e; ) {
    if (o.push(e), e.classList.contains("vfm"))
      return o;
    e = e.parentElement;
  }
  return o;
}, ho = (e, o) => {
  let l = !1;
  return mo(e).forEach((u) => {
    po(u) && yo(u, o) && (l = !0);
  }), l;
}, je = (e) => N.some(() => ho(e, -ne)), se = (e) => {
  const o = e || window.event;
  return je(o.target) || o.touches.length > 1 ? !0 : (o.preventDefault && o.preventDefault(), !1);
}, wo = (e) => {
  if (X === void 0) {
    const o = !!e && e.reserveScrollBarGap === !0, l = window.innerWidth - document.documentElement.clientWidth;
    if (o && l > 0) {
      const s = parseInt(getComputedStyle(document.body).getPropertyValue("padding-right"), 10);
      X = document.body.style.paddingRight, document.body.style.paddingRight = `${s + l}px`;
    }
  }
  W === void 0 && (W = document.body.style.overflow, document.body.style.overflow = "hidden");
}, bo = () => {
  X !== void 0 && (document.body.style.paddingRight = X, X = void 0), W !== void 0 && (document.body.style.overflow = W, W = void 0);
}, To = (e) => e ? e.scrollHeight - e.scrollTop <= e.clientHeight : !1, So = (e, o) => (ne = e.targetTouches[0].clientY - Ne, je(e.target) ? !1 : o && o.scrollTop === 0 && ne > 0 || To(o) && ne < 0 ? se(e) : (e.stopPropagation(), !0)), Mo = (e, o) => {
  if (!e) {
    console.error(
      "disableBodyScroll unsuccessful - targetElement must be provided when calling disableBodyScroll on IOS devices."
    );
    return;
  }
  if (N.some((s) => s.targetElement === e))
    return;
  const l = {
    targetElement: e,
    options: o || {}
  };
  N = [...N, l], He ? (e.ontouchstart = (s) => {
    s.targetTouches.length === 1 && (Ne = s.targetTouches[0].clientY);
  }, e.ontouchmove = (s) => {
    s.targetTouches.length === 1 && So(s, e);
  }, le || (document.addEventListener("touchmove", se, we ? { passive: !1 } : void 0), le = !0)) : wo(o);
}, go = (e) => {
  if (!e) {
    console.error(
      "enableBodyScroll unsuccessful - targetElement must be provided when calling enableBodyScroll on IOS devices."
    );
    return;
  }
  N = N.filter((o) => o.targetElement !== e), He ? (e.ontouchstart = null, e.ontouchmove = null, le && N.length === 0 && (document.removeEventListener("touchmove", se, we ? { passive: !1 } : void 0), le = !1)) : N.length || bo();
};
function Co(e, o) {
  const { lockScrollEl: l, modelValueLocal: s } = o;
  let u;
  I(l, (n) => {
    n && (u = n);
  }, { immediate: !0 }), I(() => e.lockScroll, (n) => {
    n ? a() : c();
  }), ye(() => {
    c();
  });
  function c() {
    u && go(u);
  }
  function a() {
    s.value && e.lockScroll && u && Mo(u, {
      reserveScrollBarGap: e.reserveScrollBarGap,
      allowTouchMove: (n) => {
        for (; n && n !== document.body; ) {
          if (n.getAttribute("vfm-scroll-lock-ignore") !== null)
            return !0;
          n = n.parentElement;
        }
        return !1;
      }
    });
  }
  return {
    enableBodyScroll: c,
    disableBodyScroll: a
  };
}
function ko(e) {
  const o = C();
  function l(u) {
    var c;
    o.value = (c = e.zIndexFn) == null ? void 0 : c.call(e, { index: u <= -1 ? 0 : u });
  }
  function s() {
    o.value = void 0;
  }
  return {
    zIndex: o,
    refreshZIndex: l,
    resetZIndex: s
  };
}
const fe = {
  beforeMount(e, { value: o }, { transition: l }) {
    e._vov = e.style.visibility === "hidden" ? "" : e.style.visibility, l && o ? l.beforeEnter(e) : G(e, o);
  },
  mounted(e, { value: o }, { transition: l }) {
    l && o && l.enter(e);
  },
  updated(e, { value: o, oldValue: l }, { transition: s }) {
    !o != !l && (s ? o ? (s.beforeEnter(e), G(e, !0), s.enter(e)) : s.leave(e, () => {
      G(e, !1);
    }) : G(e, o));
  },
  beforeUnmount(e, { value: o }) {
    G(e, o);
  }
};
function G(e, o) {
  e.style.visibility = o ? e._vov : "hidden";
}
const De = (e) => {
  if (e instanceof MouseEvent) {
    const { clientX: o, clientY: l } = e;
    return { x: o, y: l };
  } else {
    const { clientX: o, clientY: l } = e.targetTouches[0];
    return { x: o, y: l };
  }
};
function Vo(e) {
  if (!e)
    return !1;
  let o = !1;
  const l = {
    get passive() {
      return o = !0, !1;
    }
  };
  return e.addEventListener("x", q, l), e.removeEventListener("x", q), o;
}
function Eo(e, {
  threshold: o = 0,
  onSwipeStart: l,
  onSwipe: s,
  onSwipeEnd: u,
  passive: c = !0
}) {
  const a = ve({ x: 0, y: 0 }), n = ve({ x: 0, y: 0 }), t = g(() => a.x - n.x), i = g(() => a.y - n.y), { max: h, abs: f } = Math, M = g(
    () => h(f(t.value), f(i.value)) >= o
  ), S = C(!1), V = g(() => M.value ? f(t.value) > f(i.value) ? t.value > 0 ? "left" : "right" : i.value > 0 ? "up" : "down" : "none"), O = (p, m) => {
    a.x = p, a.y = m;
  }, E = (p, m) => {
    n.x = p, n.y = m;
  };
  let T, D;
  function k(p) {
    T.capture && !T.passive && p.preventDefault();
    const { x: m, y: R } = De(p);
    O(m, R), E(m, R), l == null || l(p), D = [
      F(e, "mousemove", P, T),
      F(e, "touchmove", P, T),
      F(e, "mouseup", r, T),
      F(e, "touchend", r, T),
      F(e, "touchcancel", r, T)
    ];
  }
  function P(p) {
    const { x: m, y: R } = De(p);
    E(m, R), !S.value && M.value && (S.value = !0), S.value && (s == null || s(p));
  }
  function r(p) {
    S.value && (u == null || u(p, V.value)), S.value = !1, D.forEach((m) => m());
  }
  let w = [];
  return Ae(() => {
    const p = Vo(window == null ? void 0 : window.document);
    c ? T = p ? { passive: !0 } : { capture: !1 } : T = p ? { passive: !1, capture: !0 } : { capture: !0 }, w = [
      F(e, "mousedown", k, T),
      F(e, "touchstart", k, T)
    ];
  }), {
    isSwiping: S,
    direction: V,
    coordsStart: a,
    coordsEnd: n,
    lengthX: t,
    lengthY: i,
    stop: () => {
      w.forEach((p) => p()), D.forEach((p) => p());
    }
  };
}
function Bo(e, o) {
  const { vfmContentEl: l, modelValueLocal: s } = o, u = 0.1, c = 300, a = C(), n = g(() => {
    if (!(e.swipeToClose === void 0 || e.swipeToClose === "none"))
      return e.showSwipeBanner ? a.value : l.value;
  }), t = C(0), i = C(!0);
  let h = q, f = !0, M, S = !1;
  const { lengthX: V, lengthY: O, direction: E, isSwiping: T } = Eo(n, {
    threshold: e.threshold,
    onSwipeStart(r) {
      h = F(document, "selectionchange", () => {
        var w;
        i.value = (w = window.getSelection()) == null ? void 0 : w.isCollapsed;
      }), M = (/* @__PURE__ */ new Date()).getTime(), S = P(r == null ? void 0 : r.target);
    },
    onSwipe() {
      var r, w, L, p;
      if (S && i.value && E.value === e.swipeToClose) {
        if (E.value === "up") {
          const m = oe(Math.abs(O.value || 0), 0, ((r = n.value) == null ? void 0 : r.offsetHeight) || 0) - (e.threshold || 0);
          t.value = m;
        } else if (E.value === "down") {
          const m = oe(Math.abs(O.value || 0), 0, ((w = n.value) == null ? void 0 : w.offsetHeight) || 0) - (e.threshold || 0);
          t.value = -m;
        } else if (E.value === "right") {
          const m = oe(Math.abs(V.value || 0), 0, ((L = n.value) == null ? void 0 : L.offsetWidth) || 0) - (e.threshold || 0);
          t.value = -m;
        } else if (E.value === "left") {
          const m = oe(Math.abs(V.value || 0), 0, ((p = n.value) == null ? void 0 : p.offsetWidth) || 0) - (e.threshold || 0);
          t.value = m;
        }
      }
    },
    onSwipeEnd(r, w) {
      if (h(), !i.value) {
        i.value = !0;
        return;
      }
      const L = (/* @__PURE__ */ new Date()).getTime(), p = w === e.swipeToClose, m = (() => {
        var J, Q;
        if (w === "up" || w === "down")
          return Math.abs((O == null ? void 0 : O.value) || 0) > u * (((J = n.value) == null ? void 0 : J.offsetHeight) || 0);
        if (w === "left" || w === "right")
          return Math.abs((V == null ? void 0 : V.value) || 0) > u * (((Q = n.value) == null ? void 0 : Q.offsetWidth) || 0);
      })(), R = L - M <= c;
      if (f && S && p && (m || R)) {
        s.value = !1;
        return;
      }
      t.value = 0;
    }
  }), D = g(() => {
    if (e.swipeToClose === "none")
      return;
    const r = (() => {
      switch (e.swipeToClose) {
        case "up":
        case "down":
          return "translateY";
        case "left":
        case "right":
          return "translateX";
      }
    })();
    return {
      class: { "vfm-bounce-back": !T.value },
      style: { transform: `${r}(${-t.value}px)` }
    };
  });
  I(
    () => i.value,
    (r) => {
      r || (t.value = 0);
    }
  ), I(
    () => s.value,
    (r) => {
      r && (t.value = 0);
    }
  ), I(
    () => t.value,
    (r, w) => {
      switch (e.swipeToClose) {
        case "down":
        case "right":
          f = r < w;
          break;
        case "up":
        case "left":
          f = r > w;
          break;
      }
    }
  );
  function k(r) {
    e.preventNavigationGestures && r.preventDefault();
  }
  function P(r) {
    const w = r == null ? void 0 : r.tagName;
    if (!w || ["INPUT", "TEXTAREA"].includes(w))
      return !1;
    const L = (() => {
      switch (e.swipeToClose) {
        case "up":
          return (r == null ? void 0 : r.scrollTop) + (r == null ? void 0 : r.clientHeight) === (r == null ? void 0 : r.scrollHeight);
        case "left":
          return (r == null ? void 0 : r.scrollLeft) + (r == null ? void 0 : r.clientWidth) === (r == null ? void 0 : r.scrollWidth);
        case "down":
          return (r == null ? void 0 : r.scrollTop) === 0;
        case "right":
          return (r == null ? void 0 : r.scrollLeft) === 0;
        default:
          return !1;
      }
    })();
    return r === n.value ? L : L && P(r == null ? void 0 : r.parentElement);
  }
  return {
    vfmContentEl: l,
    swipeBannerEl: a,
    bindSwipe: D,
    onTouchStartSwipeBanner: k
  };
}
const Ye = Symbol("vfm");
let H;
const Oo = (e) => H = e, Do = {
  install: q,
  modals: [],
  openedModals: [],
  openedModalOverlays: [],
  dynamicModals: [],
  modalsContainers: C([]),
  get: () => {
  },
  toggle: () => {
  },
  open: () => {
  },
  close: () => {
  },
  closeAll: () => Promise.allSettled([])
}, Lo = () => Ie() && qe(Ye, Do) || H;
function Yo() {
  const e = _([]), o = _([]), l = _([]), s = _([]), u = C([]), c = te({
    install(a) {
      a.provide(Ye, c), a.config.globalProperties.$vfm = c;
    },
    modals: e,
    openedModals: o,
    openedModalOverlays: l,
    dynamicModals: s,
    modalsContainers: u,
    get(a) {
      return e.find((n) => {
        var t, i;
        return ((i = (t = Z(n)) == null ? void 0 : t.value.modalId) == null ? void 0 : i.value) === a;
      });
    },
    toggle(a, n) {
      var i;
      const t = c.get(a);
      return (i = Z(t)) == null ? void 0 : i.value.toggle(n);
    },
    open(a) {
      return c.toggle(a, !0);
    },
    close(a) {
      return c.toggle(a, !1);
    },
    closeAll() {
      return Promise.allSettled(
        o.reduce((a, n) => {
          const t = Z(n), i = t == null ? void 0 : t.value.toggle(!1);
          return i && a.push(i), a;
        }, [])
      );
    }
  });
  return Oo(c), c;
}
function Z(e) {
  var o;
  return (o = e == null ? void 0 : e.exposed) == null ? void 0 : o.modalExposed;
}
const Po = me({ inheritAttrs: !1 }), Ao = /* @__PURE__ */ me({
  ...Po,
  __name: "VueFinalModal",
  props: ao,
  emits: ["update:modelValue", "beforeOpen", "opened", "beforeClose", "closed", "clickOutside"],
  setup(e, { expose: o, emit: l }) {
    const s = e, u = l, c = Re(), a = Ie(), { modals: n, openedModals: t, openedModalOverlays: i } = K(), h = C(), f = C(), { focus: M, blur: S } = vo(s, { focusEl: h }), { zIndex: V, refreshZIndex: O, resetZIndex: E } = ko(s), { modelValueLocal: T } = fo(s, u, { open: We, close: Me }), { enableBodyScroll: D, disableBodyScroll: k } = Co(s, {
      lockScrollEl: h,
      modelValueLocal: T
    });
    let P = q;
    const {
      visible: r,
      contentVisible: w,
      contentListeners: L,
      contentTransition: p,
      overlayVisible: m,
      overlayListeners: R,
      overlayTransition: J,
      enterTransition: Q,
      leaveTransition: xe
    } = uo(s, {
      modelValueLocal: T,
      onEntering() {
        z(() => {
          k(), M();
        });
      },
      onEnter() {
        u("opened"), P("opened");
      },
      onLeave() {
        $(t, a), E(), D(), u("closed"), P("closed");
      }
    }), { onEsc: ze, onMouseupRoot: Ge, onMousedown: be } = co(s, u, { vfmRootEl: h, vfmContentEl: f, visible: r, modelValueLocal: T }), {
      swipeBannerEl: $e,
      bindSwipe: Ue,
      onTouchStartSwipeBanner: Te
    } = Bo(s, { vfmContentEl: f, modelValueLocal: T }), Se = g(() => a ? t.indexOf(a) : -1);
    I([() => s.zIndexFn, Se], () => {
      r.value && O(Se.value);
    }), Ae(() => {
      de(n, a);
    }), s.modelValue && (T.value = !0);
    function We() {
      let d = !1;
      return u("beforeOpen", { stop: () => d = !0 }), d ? !1 : (de(t, a), de(i, a), ie(), Q(), !0);
    }
    function Me() {
      let d = !1;
      return u("beforeClose", { stop: () => d = !0 }), d ? !1 : ($(i, a), ie(), S(), xe(), !0);
    }
    ye(() => {
      D(), $(n, a), $(t, a), S(), ie();
    });
    async function ie() {
      await z();
      const d = i.filter((y) => {
        var A;
        const b = Z(y);
        return (b == null ? void 0 : b.value.overlayBehavior.value) === "auto" && !((A = b == null ? void 0 : b.value.hideOverlay) != null && A.value);
      });
      d.forEach((y, b) => {
        const A = Z(y);
        A != null && A.value && (A.value.overlayVisible.value = b === d.length - 1);
      });
    }
    const Xe = re(() => s.modalId), ge = re(() => s.hideOverlay), Ze = re(() => s.overlayBehavior), Ke = g(() => ({
      modalId: Xe,
      hideOverlay: ge,
      overlayBehavior: Ze,
      overlayVisible: m,
      toggle(d) {
        return new Promise((y) => {
          P = ro((A) => y(A));
          const b = typeof d == "boolean" ? d : !T.value;
          T.value = b;
        });
      }
    }));
    return o({
      modalExposed: Ke
    }), (d, y) => (B(), U(Je, {
      to: d.teleportTo ? d.teleportTo : void 0,
      disabled: !d.teleportTo
    }, [
      d.displayDirective !== "if" || v(r) ? ae((B(), j("div", x({ key: 0 }, v(c), {
        ref_key: "vfmRootEl",
        ref: h,
        class: ["vfm vfm--fixed vfm--inset", { "vfm--prevent-none": d.background === "interactive" }],
        style: { zIndex: v(V) },
        role: "dialog",
        "aria-modal": "true",
        onKeydown: y[7] || (y[7] = Qe(() => v(ze)(), ["esc"])),
        onMouseup: y[8] || (y[8] = Ce(() => v(Ge)(), ["self"])),
        onMousedown: y[9] || (y[9] = Ce((b) => v(be)(b), ["self"]))
      }), [
        ge.value ? Y("", !0) : (B(), U(ke, x({ key: 0 }, v(J), Ve(v(R))), {
          default: pe(() => [
            d.displayDirective !== "if" || v(m) ? ae((B(), j("div", {
              key: 0,
              class: _e(["vfm__overlay vfm--overlay vfm--absolute vfm--inset vfm--prevent-none", d.overlayClass]),
              style: eo(d.overlayStyle),
              "aria-hidden": "true"
            }, null, 6)), [
              [ue, d.displayDirective !== "show" || v(m)],
              [v(fe), d.displayDirective !== "visible" || v(m)]
            ]) : Y("", !0)
          ]),
          _: 1
        }, 16)),
        oo(ke, x(v(p), Ve(v(L))), {
          default: pe(() => [
            d.displayDirective !== "if" || v(w) ? ae((B(), j("div", x({
              key: 0,
              ref_key: "vfmContentEl",
              ref: f,
              class: ["vfm__content vfm--outline-none", [d.contentClass, { "vfm--prevent-auto": d.background === "interactive" }]],
              style: d.contentStyle,
              tabindex: "0"
            }, v(Ue), {
              onMousedown: y[6] || (y[6] = () => v(be)())
            }), [
              Ee(d.$slots, "default", Fe(to({ close: Me }))),
              d.showSwipeBanner ? (B(), j("div", {
                key: 0,
                ref_key: "swipeBannerEl",
                ref: $e,
                class: "vfm-swipe-banner-container",
                onTouchstart: y[2] || (y[2] = (b) => v(Te)(b))
              }, [
                Ee(d.$slots, "swipe-banner", {}, () => [
                  ee("div", {
                    class: "vfm-swipe-banner-back",
                    onTouchstart: y[0] || (y[0] = (b) => d.swipeToClose === "left" && b.preventDefault())
                  }, null, 32),
                  ee("div", {
                    class: "vfm-swipe-banner-forward",
                    onTouchstart: y[1] || (y[1] = (b) => d.swipeToClose === "right" && b.preventDefault())
                  }, null, 32)
                ])
              ], 544)) : !d.showSwipeBanner && d.preventNavigationGestures ? (B(), j("div", {
                key: 1,
                class: "vfm-swipe-banner-container",
                onTouchstart: y[5] || (y[5] = (b) => v(Te)(b))
              }, [
                ee("div", {
                  class: "vfm-swipe-banner-back",
                  onTouchstart: y[3] || (y[3] = (b) => d.swipeToClose === "left" && b.preventDefault())
                }, null, 32),
                ee("div", {
                  class: "vfm-swipe-banner-forward",
                  onTouchstart: y[4] || (y[4] = (b) => d.swipeToClose === "right" && b.preventDefault())
                }, null, 32)
              ], 32)) : Y("", !0)
            ], 16)), [
              [ue, d.displayDirective !== "show" || v(w)],
              [v(fe), d.displayDirective !== "visible" || v(w)]
            ]) : Y("", !0)
          ]),
          _: 3
        }, 16)
      ], 16)), [
        [ue, d.displayDirective !== "show" || v(r)],
        [v(fe), d.displayDirective !== "visible" || v(r)]
      ]) : Y("", !0)
    ], 8, ["to", "disabled"]));
  }
});
function K() {
  const e = Lo();
  if (!e)
    throw new Error(
      `[Vue Final Modal]: getActiveVfm was called with no active Vfm. Did you forget to install vfm?
	const vfm = createVfm()
	app.use(vfm)
This will fail in production.`
    );
  return e;
}
function Le(e, o = Ao) {
  const { component: l, slots: s, ...u } = e, c = typeof s > "u" ? {} : Object.fromEntries(Object.entries(s).map(([a, n]) => he(n) ? [a, n] : "component" in n ? [a, {
    ...n,
    component: te(n.component)
  }] : [a, te(n)]));
  return {
    ...u,
    component: te(l || o),
    slots: c
  };
}
function xo(e) {
  const o = ve({
    id: Symbol("useModal"),
    modelValue: !!(e != null && e.defaultModelValue),
    resolveOpened: () => {
    },
    resolveClosed: () => {
    },
    attrs: {},
    ...Le(e)
  });
  so(() => {
    o != null && o.keepAlive || n();
  }), o.modelValue === !0 && (H ? H == null || H.dynamicModals.push(o) : z(() => {
    const t = K();
    t == null || t.dynamicModals.push(o);
  }));
  async function l() {
    let t;
    return H ? t = H : (await z(), t = K()), o.modelValue ? Promise.resolve("[Vue Final Modal] modal is already opened.") : (n(), o.modelValue = !0, t.dynamicModals.push(o), new Promise((i) => {
      o.resolveOpened = () => i("opened");
    }));
  }
  function s() {
    return o.modelValue ? (o.modelValue = !1, new Promise((t) => {
      o.resolveClosed = () => t("closed");
    })) : Promise.resolve("[Vue Final Modal] modal is already closed.");
  }
  function u(t) {
    const { slots: i, ...h } = Le(t, o.component);
    t.defaultModelValue !== void 0 && (o.defaultModelValue = t.defaultModelValue), (t == null ? void 0 : t.keepAlive) !== void 0 && (o.keepAlive = t == null ? void 0 : t.keepAlive), c(o, h), i && Object.entries(i).forEach(([f, M]) => {
      const S = o.slots[f];
      he(S) ? o.slots[f] = M : Pe(S) && Pe(M) ? c(S, M) : o.slots[f] = M;
    });
  }
  function c(t, i) {
    i.component && (t.component = i.component), i.attrs && a(t.attrs, i.attrs);
  }
  function a(t, i) {
    return Object.entries(i).forEach(([h, f]) => {
      t[h] = f;
    }), t;
  }
  function n() {
    const t = K(), i = t.dynamicModals.indexOf(o);
    i !== -1 && t.dynamicModals.splice(i, 1);
  }
  return {
    options: o,
    open: l,
    close: s,
    patchOptions: u,
    destroy: n
  };
}
function zo(e) {
  return e;
}
function Pe(e) {
  return "component" in e || "attrs" in e;
}
function Io(e, o) {
  return Object.keys(o).reduce((l, s) => (l[s] = e[s], l), {});
}
function Ro(e) {
  return e ? {
    "onUpdate:modelValue": (o) => e("update:modelValue", o),
    onBeforeClose: (o) => e("beforeClose", o),
    onClosed: () => e("closed"),
    onBeforeOpen: (o) => e("beforeOpen", o),
    onOpened: () => e("opened"),
    /** onClickOutside will only be emitted when clickToClose equal to `false` */
    onClickOutside: () => e("clickOutside")
  } : {};
}
function Go(e) {
  const { props: o, modalProps: l, emit: s } = e, u = g(() => Io(o, l)), c = Ro(s), a = Re();
  return g(() => ({
    ...u.value,
    ...c,
    ...a
  }));
}
const Fo = ["innerHTML"], $o = /* @__PURE__ */ me({
  __name: "ModalsContainer",
  setup(e) {
    const { modalsContainers: o, dynamicModals: l } = K(), s = Symbol("ModalsContainer"), u = g(() => {
      var n;
      return s === ((n = o.value) == null ? void 0 : n[0]);
    });
    o.value.push(s), ye(() => {
      o.value = o.value.filter((n) => n !== s);
    });
    function c(n) {
      var t, i, h;
      (i = (t = l[n]) == null ? void 0 : t.resolveClosed) == null || i.call(t), (h = l[n]) != null && h.keepAlive || l.splice(n, 1);
    }
    function a(n) {
      var t, i;
      (i = (t = l[n]) == null ? void 0 : t.resolveOpened) == null || i.call(t);
    }
    return (n, t) => u.value ? (B(!0), j(no, { key: 0 }, Be(v(l), (i, h) => (B(), U(ce(i.component), x({
      key: i.id
    }, {
      displayDirective: i != null && i.keepAlive ? "show" : void 0,
      ...typeof i.attrs == "object" ? i.attrs : {}
    }, {
      modelValue: i.modelValue,
      "onUpdate:modelValue": (f) => i.modelValue = f,
      onClosed: () => c(h),
      onOpened: () => a(h)
    }), lo({ _: 2 }, [
      Be(i.slots, (f, M) => ({
        name: M,
        fn: pe(() => [
          v(he)(f) ? (B(), j("div", {
            key: 0,
            innerHTML: f
          }, null, 8, Fo)) : "component" in f ? (B(), U(ce(f.component), Fe(x({ key: 1 }, f.attrs)), null, 16)) : (B(), U(ce(f), { key: 2 }))
        ])
      }))
    ]), 1040, ["modelValue", "onUpdate:modelValue", "onClosed", "onOpened"]))), 128)) : Y("", !0);
  }
});
export {
  $o as ModalsContainer,
  Ao as VueFinalModal,
  Yo as createVfm,
  Z as getModalExposed,
  xo as useModal,
  zo as useModalSlot,
  K as useVfm,
  Go as useVfmAttrs,
  ao as vueFinalModalProps
};
