import VueFinalModal from './components/VueFinalModal/VueFinalModal.vue';
import type { ComponentProps, ComponentType, UseModalOptions, UseModalReturnType, Vfm } from './Modal';
/**
 * Returns the vfm instance. Equivalent to using `$vfm` inside
 * templates.
 */
export declare function useVfm(): Vfm;
/**
 * Create a dynamic modal.
 */
export declare function useModal<T extends ComponentType = typeof VueFinalModal>(_options: UseModalOptions<T>): UseModalReturnType<T>;
export declare function useModalSlot<T extends ComponentType>(options: {
    component: T;
    attrs?: ComponentProps<T>;
}): {
    component: T;
    attrs?: ComponentProps<T> | undefined;
};
export declare function pickModalProps(props: any, modalProps: any): Record<string, any>;
export declare function byPassAllModalEvents(emit?: InstanceType<typeof VueFinalModal>['$emit']): {
    'onUpdate:modelValue'?: undefined;
    onBeforeClose?: undefined;
    onClosed?: undefined;
    onBeforeOpen?: undefined;
    onOpened?: undefined;
    /** onClickOutside will only be emitted when clickToClose equal to `false` */
    onClickOutside?: undefined;
} | {
    'onUpdate:modelValue': (val: boolean) => void;
    onBeforeClose: (payload: {
        stop: () => void;
    }) => void;
    onClosed: () => void;
    onBeforeOpen: (payload: {
        stop: () => void;
    }) => void;
    onOpened: () => void;
    /** onClickOutside will only be emitted when clickToClose equal to `false` */
    onClickOutside: () => void;
};
export declare function useVfmAttrs(options: {
    props: Record<any, any>;
    modalProps: Record<any, any>;
    emit?: any;
}): import("vue").ComputedRef<{
    'onUpdate:modelValue'?: undefined;
    onBeforeClose?: undefined;
    onClosed?: undefined;
    onBeforeOpen?: undefined;
    onOpened?: undefined;
    /** onClickOutside will only be emitted when clickToClose equal to `false` */
    onClickOutside?: undefined;
} | {
    'onUpdate:modelValue': (val: boolean) => void;
    onBeforeClose: (payload: {
        stop: () => void;
    }) => void;
    onClosed: () => void;
    onBeforeOpen: (payload: {
        stop: () => void;
    }) => void;
    onOpened: () => void;
    /** onClickOutside will only be emitted when clickToClose equal to `false` */
    onClickOutside: () => void;
}>;
